import getopt,sys,os,urllib,urllib2,json,time

#Version for Python 2.7

def usage():
	print "Usage: " + sys.argv[0]
	print "-h display this notice"
	print "-D domain"
	print "-u username"
	print "-p password"
	print "-a action [index|get]"
	print "-d target directory [required if -a get]"
	print "-k keep files on server [used if -a get]"
	print "-s sleep timer [optional], default: 0.5"
	print "-i Skip already downloaded Files, default: no (if -k is not set delete them from the server regardless if downloaded or not)"
	print "-I Insecure Disable Https"

class getOptions():
	def Initialize(self):
		result = {}
		opts,args = getopt.getopt(sys.argv[1:], 'D:u:p:a:d:kniIs:')

		if(len(sys.argv) < 4):
			usage()
			sys.exit()

		for opt, arg in opts:
			if opt in ('-h', '--help'):
				usage()
				sys.exit()
			elif opt in ('-D', '--domain'):
				result['domain'] = arg
			elif opt in ('-u', '--username'):
				result['username'] = arg
			elif opt in ('-p', '--password'):
				result['password'] = arg
			elif opt in ('-a', '--action'):
				result['action'] = arg
			elif opt in ('-d', '--directory'):
				result['targetdir'] = arg
			elif opt in ('-k', '--keep'):
				result['keep'] = True
			elif opt in ('-s', '--sleep'):
				arg = float(arg)
				if arg >= 0:
					result['sleep'] = arg
				else:
					result['sleep'] = 0
			elif opt in ('-i','--skipdownloaded'):
				result['override'] = False
			elif opt in ('-I','--nohttps'):
				result['protocol'] = 'http://'

		try:
			result['domain']
		except:
			result['domain'] = None
		try:
			result['username']
		except:
			result['username'] = None
		try:
			result['password']
		except:
			result['password'] = None
		try:
			result['action']
		except:
			result['action'] = None
		try:
			result['targetdir']
		except:
			result['targetdir'] = None
		try:
			result['keep']
		except:
			result['keep'] = False
		try:
			result['sleep']
		except:
			result['sleep'] = 0.5
		try:
			result['override']
		except:
			result['override'] = True
		try:
			result['protocol']
		except:
			result['protocol'] = 'https://'

		if(result['domain'] == None or result['username'] == None or result['password'] == None or (result['action'] == 'get' and result['targetdir'] == None)):
			usage()
			sys.exit()
		else:
			return result

data = getOptions().Initialize()
domain = data['domain']
username = data['username']
password = data['password']
action = data['action']
targetdir = data['targetdir']
keep = data['keep']
sleep = data['sleep']
src = data['protocol']+domain+"/recordings.php?username="+username+"&password="+password+"&action="+action
override = data['override']

class Recordings():
	#####################################
	# Connections to remote .php script #
	#####################################

	# function to get an encoded JSON array and returns decoded object
	def getJSON(self,src):
		req = urllib2.Request(src)
		opener = urllib2.build_opener()
		f = opener.open(req)
		return json.load(f)

	# function to get results from a URL that doesn't return a JSON object
	def getURL(self,src):
		req = urllib2.Request(src)
		response = urllib2.urlopen(req)
		contents = response.read()
		return contents

	########################################
	# Functions for copying recorded calls #
	########################################

	# function to create a folder if it does not yet exist
	def createFolder(self,path):
		new_folder_path = path
		print "Checking if "+new_folder_path+" exists ..."
		if(not os.path.isdir(new_folder_path)):
			print "    Creating "+new_folder_path+" ...\n"
			os.makedirs(new_folder_path)
		else:
			print "    "+new_folder_path+" exists, skipping ...\n"
		return new_folder_path

	# function to create a file to path/filename
	def createFile(self,username,password,domain,file_id,local_path,filename):
		src = data['protocol']+domain+"/recordings.php?username="+username+"&password="+password+"&action=download&file_id="+urllib.quote_plus(file_id)
		filename = filename.replace('*','')
		file_path = os.path.join(local_path,filename)
		print "Checking if "+file_path+" exists ...\n"
		if(override):
			new_file_path = self.getNewFilePath(file_path)
			saveFile = True
		else:
			new_file_path = file_path
			if(os.path.exists(new_file_path)):
				saveFile = False
			else:
				saveFile = True
		if(saveFile):
			print "    Creating "+new_file_path+" ...\n"
			contents = self.getURL(src)
			with open(new_file_path, 'wb') as f:
				f.write(contents)
		else:
			print "    Skipping "+new_file_path+" ...\n"

	# function to check if file already exists and returns an alternative filename since we do not want to overwrite existing files
	def getNewFilePath(self,path,append="0"):
		if(append != "0"):
			check_path = str(path).rsplit('.')[0]+"-"+append+"."+str(path).rsplit('.')[1]
		else:
			check_path = str(path)

		if(os.path.exists(check_path)):
			append = str(int(append) + 1)
			print "    "+check_path+" exists, checking "+str(path).rsplit('.')[0]+"-"+append+"."+str(path).rsplit('.')[1]+" ..."
			check_path = self.getNewFilePath(path,append)

		return check_path

	##########################################
	# Functions for deleting files on server #
	##########################################

	# function to delete paths on server; if path is a folder, it's only deleted if it's empty
	def deleteFile(self,username,password,domain,file_id,local_path):
		# check if the file or folder has been copied before we delete it
		if(os.path.exists(local_path)):
			src = data['protocol']+domain+"/recordings.php?username="+username+"&password="+password+"&action=delete&file_id="+urllib.quote_plus(file_id)
			contents = self.getURL(src)
			if(contents != ''):
				print contents
			else:
				print file_id+" deleted successfully on remote server!\n"
		else:
			print local_path+" does not yet exist, skipping the deleting process of file "+file_id+". Please restart this script to try again.\n"

	#################################
	# Functions according to action #
	#################################

	# function to check recordings saved at src
	def showContents(self,src):
		contents = self.getJSON(src)
		print "\nThese files are available:"
		if(len(contents)>0):
			for path in contents:
				path = path.replace('~','/')
				path_split = path.rsplit('/')
				file_id = path_split[len(path_split)-1]
				file_data = file_id.rsplit('__')
				callertime = file_data[0]
				caller = file_data[1]
				called = file_data[2]
				print "    "+path_split[len(path_split)-2]+" "+callertime+" from "+caller+" to "+called
		else:
			print "    <none>"

	# function to move folders and files from src to dst
	def moveContents(self,username,password,domain,src,dst,keep,sleep):
		print "Starting to copy files ..."
		contents = self.getJSON(src)
		if(len(contents)>0):
			for path in contents:
				# a few decodings
				server_path = path.replace('~','/')
				path_split = server_path.rsplit('/')
				folder = ''
				index = 0
				while(index < len(path_split)-1):
					folder = folder + path_split[index] + "/"
					index = index + 1
				filename = path_split[index]+"__"+username+".wav"

				# getting valid local_path and copy
				local_path = os.path.join(dst,os.path.normpath(folder))
				new_folder_path = self.createFolder(local_path)
				self.createFile(username,password,domain,path,new_folder_path,filename)

				# delete file
				if not keep:
					local_path = os.path.join(local_path,filename)
					self.deleteFile(username,password,domain,path,local_path)

				# some systems cause problems when there are too many downloads one after another
				time.sleep(sleep)
		else:
			print "    No files available!"

if(action == 'index'):
	Recordings().showContents(src)
elif(action == 'get'):
	Recordings().moveContents(username,password,domain,src,targetdir,keep,sleep)
